fidelitycard/urls.py
from django.contrib import admin
from django.urls import path, include
from django.urls import path
from django.conf.urls import url, include
from pages import views

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('', include('pages.urls')),
    url(r'^$', views.home_page, name='home'),

    # url(r'^pages/',views.user_page,name='user_page'),

    url(r'^special/', views.special, name='special'),
    url(r'^pages/', include('pages.urls')),

    url(r'^logout/$', views.user_logout, name='logout'),

]

pages/urls.py
from django.contrib import admin

from django.urls import path

from . import views

# from pages.views import base_view, login_page

# from pages.views import AboutView
from django.conf.urls import url

app_name = 'pages'

urlpatterns = [

    path('', views.home_page, name='home_view'),
    path('card_list/', views.CardListView.as_view(), name='card_list'),
    path('card_add/', views.CardCreateView.as_view(), name='card_add'),
    path('card_detail/<int:pk>', views.CardDetailView.as_view(), name='card_detail'),
    path('card_delete/<int:pk>', views.CardDeleteView.as_view(), name='card_delete'),
    path('user_page/', views.display_photo_user, name='user_page'),
    path('test/', views.display_card_photo, name='test'),
    # path('profile_update/',views.update_user, name='profile_update'),
    # path('profile_update/', views.ProfileUpdateView.as_view(), name='profile_update'),
    path('profile/',views.view_profile,name='profile'),
    path('profile/',views.view_profile_info, name='profile'),
    path('profile_update/',views.edit_profile, name='profile_update'),
    path('change_password/',views.change_password, name='change_password'),
    path('password/',views.change_password, name='password'),
    path('add_card_of_shop/', views.update_cards_for_shop, name='add_card_of_shop'),

    url('^user_page/$', views.user_page, name='user_page'),
    url('^display_cards/$', views.display_all_cards, name='display_cards'),

    url(r'^register/$', views.register, name='register'),
    url(r'^user_login/$', views.user_login, name='user_login'),

]

pages/models.py
from django.db import models
from django.contrib.auth.models import User
from django.contrib.auth import get_user_model


# Create your models here.
#
# class User(models.Model):
#     name = models.TextField(max_length=120)
#     surname = models.TextField(max_length=120)
#     email = models.EmailField()
#     phone = models.TextField()


class UserProfileInfo(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    profile_pic = models.ImageField(upload_to='static/profile_pics', blank=True)


    def __str__(self):
        return self.user.username


class Shop(models.Model):
    shop_name = models.TextField(max_length=50)

    def __str__(self):
        return self.shop_name


class CardType(models.Model):
    card_name = models.TextField(max_length=50)
    card_picture = models.ImageField(upload_to='static/profile_pics', blank=False)
    shop_id = models.ForeignKey(Shop, on_delete=models.CASCADE, null=True)

    def __str__(self):
        return self.card_name


class Card(models.Model):
    shop_id = models.ForeignKey(Shop, on_delete=models.CASCADE, null=True)
    card_id = models.ForeignKey(CardType, on_delete=models.CASCADE, null=True)
    client_id = models.ForeignKey(User, on_delete=models.CASCADE)

# class CardsInfo(models.Model):
#     shop_id=models.CharField(max_length=50)
#     shop_name=models.TextField()
#     card_name=models.TextField()
#     card_image=models.ImageField(upload_to='card_pics',blank=True)
#

pages/forms.py
import re

from django import forms
from django.contrib.auth.forms import UserChangeForm
# from pages.models import UserProfileInfo
from django.contrib.auth.models import User

from pages.models import UserProfileInfo, Card, Shop, CardType


class MyFormLogin(forms.ModelForm):
    email = forms.EmailField()
    password = forms.CharField(widget=forms.PasswordInput())

    class Meta:
        model = User
        fields = ("username", "password", "email", "last_name", "first_name")

    def clean_password(self, *args, **kwargs):
        password = self.cleaned_data.get("password")
        if len(password) < 10:
            raise forms.ValidationError("Length password should be at least 11")
        elif re.search('[0-9]', password) is None:
            raise forms.ValidationError("Your password must contain at least one digit")
        elif re.search('[A-Z]', password) is None:
            raise forms.ValidationError("Your password must contain a capital letter in it")
        return password

    def clean_first_name(self, *args, **kwargs):
        if self.cleaned_data["first_name"].strip() == '':
            raise forms.ValidationError("You must enter a value for First Name")
        return self.cleaned_data["first_name"]

    def clean_last_name(self, *args, **kwargs):
        if self.cleaned_data["last_name"].strip() == '':
            raise forms.ValidationError("You must enter a value for Last Name")
        return self.cleaned_data["last_name"]


class UserProfileInfoForm(forms.ModelForm):
    class Meta:
        model = UserProfileInfo
        fields = ("profile_pic",)
    # def clean_profile_pic(self):
    #     if self.clean_profile_pic["profile_pic"]


class EditProfileForm(UserChangeForm):
    class Meta:
        model = User
        fields = ("email", "last_name", "first_name")
    # def clean_first_name(self,*args,**kwargs):
    #     if self.cleaned_data["first_name"].strip() == '':
    #         raise forms.ValidationError("You must enter a value for First Name")
    #     return self.cleaned_data["first_name"]
    # def clean_last_name(self, *args, **kwargs):
    #     if self.cleaned_data["last_name"].strip() == '':
    #         raise forms.ValidationError("You must enter a value for Last Name")
    #     return self.cleaned_data["last_name"]


# class EditUserProfileInfoForm(UserProfileInfoForm):
#     class meta():
#         model=UserProfileInfo
#         field=("profile_pic")


class CardCreateForm(forms.ModelForm):
    class Meta:
        model = Card
        fields = ("shop_id","card_id")

    shop_id = forms.ModelChoiceField(required=True, widget=forms.Select, queryset=Shop.objects.all())

    def __init__(self, *args, **kwargs):
        super(CardCreateForm, self).__init__(*args, **kwargs)
        self.fields['card_id'] = forms.ModelChoiceField(required=True, widget=forms.Select,
                                                        queryset=CardType.objects.none())
        if 'shop_id' in self.data:
            shop_id = int(self.data.get('shop_id'))
            self.fields['card_id'].queryset = CardType.objects.filter(shop_id=shop_id)
        print(self.fields['shop_id'].widget.choices.__dict__)
        # elif self.instance.pk:
        #     self.fields['card_id'].queryset = self.instance.shop.city_set

templates/add_card_of_shop.html
<select name="card_name" required id="id_card_name">
    <option value="">---------</option>
    {% for card in cards %}
        <option value="{{ card.pk }}">{{ card.card_name }}</option>
    {% endfor %}
</select>

templates/base.html
<!DOCTYPE html>
<html>
<head>

    <meta charset="utf-8">
    <title>FidelityCard</title>

    <link rel="stylesheet"
          href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"
          integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="/static/base.css">

</head>

<body >
<nav class="navbar navbar-default navbar-static-top">
    <div class="container">
        <ul class="nav navbar-nav">

            <li><a class="navbar-brand" href="{% url 'home' %}">Home</a></li>

            {% if user.is_authenticated %}
                <li><a class="navbar-link" href="{% url 'pages:user_page' %}">Profile</a></li>
                <li><a href="{% url 'logout' %}">Logout</a></li>


            {% else %}
                {#                <li><a class="navbar-link" href="{% url 'pages:user_login' %}">Login</a></li>#}
                <li><a class="navbar-link" href="{% url 'pages:register' %}">Register</a></li>

            {% endif %}
        </ul>
    </div>
</nav>
<div class="container">

    {% block body_block %}

    {% endblock %}
</div>
</body>
</html>

templates/card_add.html
{% extends 'base.html' %}


{% block body_block %}

    {#{% block content %}#}
    {#    <form action="" method="post"> {% csrf_token %}#}
    {#        {{ form.as_p }}#}
    <p align="center" style="color:whitesmoke;"> Add Card</p>

    <form id="add_card" add-card-url="{% url 'pages:add_card_of_shop' %}" method="post" action="">
        {% csrf_token %}
        {# A more "HTML" way of creating the login form#}
{#        <ul align="center">#}
{##}
{#            <label for="card_number">Card Number:</label>#}
{#            <input type="text" name="card_number" placeholder="Card_number">#}
{#        </ul>#}
{#        <ul align="center">#}
{#            <label for="card_name">Card Name:</label>#}
{#            <input type="card_name" name="card_name" placeholder="Card_name">#}
{#        </ul>#}
{#         <ul align="center">#}
{#            <label for="shop_name">Shop Name:</label>#}
{#            <input type="shop_name" name="shop_name" placeholder="Shop_name">#}
{#        </ul>#}
       {{ form.as_p }}


        <ul align="center">
             <input type="submit" value="Create"/>
        </ul>

    </form>
<script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
  <script>
    $("#id_shop_id").change(function () {
      console.log("test");
        var url = $("#add_card").attr("add-card-url");
        var shop = $(this).val();

     $.ajax({
        url: url,
        data: {
          'shop': shop
        },
        success: function(data) {
            $("#id_card_id").html(data);
        }
      });

    });
  </script>

    {#    <input type="submit" value="Create"/>#}

{#    </form>#}
{% endblock %}

</body>
</html>

templates/card_delete.html
{# templates/card_delete.html #}
{% extends 'base.html' %}
{% block body_block %}
 <form action="" method="post"> {% csrf_token %}
 <p>

 </p>
     <p> Are you sure you want to delete selected card? </p>
 <input type="submit" value="Delete"/>
 </form>
{% endblock %}

templates/card_detail.html
{# templates/card_detail.html #}
{% extends 'base.html' %}
{% block body_block %}
    <table>
        <tr>
            <td>
                <img src="{{ card.card_id.card_picture.url }}" width="190px" height="130px">
            </td>
            <td>
                <p>PK: {{ card.pk }}</p>
                <p>Name: {{ card.card_id.card_name }}</p>
                <p>Shop Name: {{ card.shop_id.shop_name }}</p>
                <p>Card Number: {{ card.card_id.id }}</p>
                <p>Client Id: {{ card.client_id }}</p>
                <br/>
                <a href="{% url 'pages:card_delete' card.pk %}">
                    Delete card
                </a>
            </td>
        </tr>
    </table>
{% endblock %}

templates/card_list.html
<!DOCTYPE html>
<html lang="en">
<head>
  <link rel="stylesheet" type="text/css" href="/static/card_list.css">

</head>
<body >
<div align="left">
<table style="color:beige" style="width:100%">
    <tr style="color:beige">
        <th></th>
        <th>Card Name</th>
        <th>Shop Name</th>
        <th>Card Number</th>
        <th></th>

    </tr>
    {% for card in cards %}
        <tr>
            <td>
                <a href="{% url 'pages:card_detail' card.pk %}">
                    <img src="{{card.card_id.card_picture.url}}" width="90px" height="70px">
                </a>
            </td>
            <td><a href="{% url 'pages:card_detail' card.pk %}"> {{ card.card_id.card_name }} </a></td>
            <td><a href="{% url 'pages:card_detail' card.pk %}"> {{ card.shop_id.shop_name }} </a></td>
            <td><a href="{% url 'pages:card_detail' card.pk %}"> {{ card.card_id.id }} </a></td>

            <td>
                <button class="button1" align="center">
                    <a href="{% url 'pages:card_delete' card.pk %}"> Delete</a></button>
            </td>


        </tr>

  {% endfor %}

</table>

</br></br></br></br></br>
</div>
<div align="center">
{#<button class="button" align="center"><a href="{% url 'pages:card_add' %}"> +</a></button>#}
</div>

</body>

templates/change_password.html
<!DOCTYPE html>
<html lang="en">
<head>
{#  <link rel="stylesheet" type="text/css" href="/static/card_list.css">#}

</head>
<body >
{##}
{#<h2 align="center"> Update personal informations </h2>#}
{#    <form method="post" action="">#}

         <form method="post" action="">


        {% csrf_token %}
    {{ form.as_p }}

            <input type="submit" value="Update"/>

</form>

</body>
</html>

templates/display_cards.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Display all the card</title>
</head>
<body>
    {% for card in all_cards %}
    <pre>  Name: {{card.card_name}}     Magazin:{{card.shop_name}}

    </pre>

    {% endfor %}


</body>
</html>

templates/home.html
{% extends 'base.html' %}
{% block body_block %}
  <link rel="stylesheet" type="text/css" href="/static/home.css">
    <div class="container">
        <h2 >Welcome {{ user.first_name }}!
            <img src="/static/home_image1.jpg" style="float:right;width:500px;height:550px;">
        </h2>
        {% if user.is_authenticated %}
            <h2 text-shadow: 2px 2px>
                Welcome to the FidelityCard App!</h2>
        {% else %}
            <h5>You can register <a href="{% url 'pages:register' %}">here</a>
                if you want to join us!
                </br>
                If you already have an account please Login!
            </h5>
            </br> </br> </br> </br> </br>


            <div class="container" align="left">

                <div class="relative" align="left">
                    <h4  align="center">Login into My Account:</h4>
                    <form method="post" action="{% url 'pages:user_login' %}">
                        {% csrf_token %}

                        <ul align="center">

                            <label for="username">Username:</label>
                            <input type="text" name="username" placeholder="Username">
                        </ul>
                        <ul align="center">
                            <label for="password">Password:</label>
                            <input type="password" name="password" placeholder="Password">
                        </ul>
                        <ul align="center">
                            <input type="submit" name="" value="Login">
                        </ul>

                    </form>
                </div>
            </div>
            </div>
        {% endif %}

    </div>


{% endblock %}

templates/login.html
{#<!DOCTYPE html>#}
{#<html>#}
{#<head>#}
{#    <style>#}
{#        input[type=text] {#}
{#            width: 15%;#}
{#            padding: 10px 10px;#}
{#            margin: 8px 0;#}
{#            box-sizing: border-box;#}
{#        }#}
{#    </style>#}
{#</head>#}
{#<body style="background-color:black;">#}
{##}
{#<p align="center" style="color:whitesmoke;"> Login</p>#}
{##}
{#<form>#}
{#    <ul align="center">#}
{#        <input type="text" id="fname" name="fname" align="left" placeholder="Email"></ul>#}
{#    <ul align="center">#}
{##}
{#        <input type="text" id="pass" name="fpass" align="left" placeholder="Password">#}
{#    </ul>#}
{#</form>#}
{##}
{#</body>#}
{#</html>#}


{% extends 'base.html' %}
{% block body_block %}
  <div class="container" >
{#    <div class="jumbotron" >#}
      <div>
      <h4 style="color:beige" align="center">Login here if you already have an account:</h4>


<form method="post" action="{% url 'pages:user_login' %}">
          {% csrf_token %}
          {# A more "HTML" way of creating the login form#}
    <ul align="center">

    <label for="username">Username:</label>
          <input type="text" name="username" placeholder="Username">
       </ul>
        <ul align="center">
<label for="password">Password:</label>
          <input type="password" name="password" placeholder="Password">
        </ul>
    <ul align="center">
<input type="submit" name="" value="Login">
       </ul>

</form>
</div>
  </div>
{% endblock %}

templates/navbar.html
<nav>
    <div align="right">

            <ul>
                <a href="login.html" target="_self" ,style="color:whitesmoke;">Home</a>
                <a href="/blog" style="color:whitesmoke;">Login</a>
                <a href="/blog" style="color:whitesmoke;">Register</a>
                <a href="/blog" style="color:whitesmoke;">About</a>
                <a href="/blog" style="color:whitesmoke;">Partners</a>
            </ul>


        </div>
</nav>

templates/partners.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>

</body>
</html>

templates/profile_update.html
<!DOCTYPE html>
<html lang="en">
<head>
{#  <link rel="stylesheet" type="text/css" href="/static/card_list.css">#}

</head>
<body >

<h2 align="center"> Update personal information </h2>
    <form method="post" action="{% url 'pages:profile_update' %}">
        {% csrf_token %}
        {{ form.as_p }}

            <input type="submit" value="Update Information"/>
<button style="width: 135px"> <a href = "{% url 'pages:change_password' %} " style="color: black">Update password</a></button>
<button style="width: 135px"> <a href = "{% url 'pages:user_page' %} " style="color: black">User Page</a></button>
</form>



</body>
</html>

templates/user_page.html
{% extends 'base.html' %}
{% block body_block %}
    <link rel="stylesheet" type="text/css" href="/static/card_list.css">

    <div style="position: absolute; right: 5%; top:10%">
        <h4 align="right" style="color:beige">
            {{ user.first_name }} {{ user.last_name }}
            {% if photo.profile_pic %}
            <img src="{{ photo.profile_pic.url }}" width="60px" height="50px">
            {% endif %}
        </h4>

        <a href="{% url 'pages:profile' %}">View Profile </a>
    </div>

    <div style="position: absolute; left: 20%; top:10%">
        <h3>Hello <br>{{ user.first_name }} {{ user.last_name }}!</h3>

        <script type="text/javascript" src="http://code.jquery.com/jquery.min.js"></script>

        <script src="js/csi.js" type="text/javascript"></script>
        <script src="js/csi.min.js" type="text/javascript"></script>
        <script src="js/jquery.js" type="text/javascript"></script>
        <script type="text/javascript">
            $(function () {
                $("#includedContent").load(href = "{% url 'pages:card_list' %}");
            })

            function bigImg(x) {
                x.style.height = "64px";
                x.style.width = "64px";
            }

            function normalImg(x) {
                x.style.height = "45px";
                x.style.width = "45px";

            }


        </script>
        <div id="includedContent"></div>
    </div>
    <div style="position: absolute; left: 5%; top:30%">


        <button class="button" align="center" onmouseover="bigImg(this)" onmouseout="normalImg(this)">
            <a href="{% url 'pages:card_add' %}" style="color:black; font-style: italic; font-size:20px" >+</a>
        </button>
        {#    <button onclick="{% url 'pages:card_add' %}">HTML Tutorial</button>#}
    </div>
{% endblock %}